<div class="wrapper" [class.modal-mode]="_modalMode">
  <app-text-field
    [label]="'Add ' + label"
    [isLarge]="false"
    [ngrxFormControl]="_searchField"
    [autocomplete]="false"
    (focus)="searchFieldFocus()"
    (blur)="searchFieldBlur()"
    (keyup)="filterListItems()"
  ></app-text-field>

  <div
    class="list-and-messages"
    [class.modal-mode]="_modalMode"
    [class.no-list-items]="totalListItemsCount === 0"
    [class.few-list-items]="totalListItemsCount < 6"
  >
    <ul>
      <li
        *ngFor="let listItem of _visibleListItems; let i = index"
        [class.active]="_keyboardActiveListItem === i && !_modalMode"
      >
        <label
          *ngIf="_modalMode"
          class="form-field__checkbox"
          [class.pending]="listItem.isPending"
        >
          <input
            type="checkbox"
            class="form-field__checkbox__input"
            [checked]="listItem.isSelected"
            id="add-modal-check-{{ listItem.value }}"
            value="listItem.value"
            (click)="addToList(listItem)"
          />
          <div class="form-field__checkbox__check">
            <div [inlineSVG]="'../assets/svg/check.svg'"></div>
          </div>
          <div class="form-field__checkbox__text">
            {{ listItem.name }}
          </div>
        </label>
        <button
          class="u-button-unstyled"
          type="button"
          (click)="addToList(listItem)"
          tabindex="-1"
          data-multiselect-list-item="true"
          *ngIf="!_modalMode"
        >
          {{ listItem.name }}
        </button>
      </li>
    </ul>

    <!--
      If the search field doesn't match anything in the list because it's
      invalid, show the invalid message. Otherwise, the "no match" message
    -->
    <ng-container
      *ngIf="_searchField.value.length > 0 && _visibleListItems.length === 0"
    >
      <div
        *ngIf="!!invalidSearchFieldText && !_validSearchField"
        class="messages"
      >
        {{ invalidSearchFieldText }}
      </div>
      <div
        *ngIf="!!noSearchFieldMatchText && _validSearchField"
        class="messages"
      >
        {{ noSearchFieldMatchText }}
      </div>
    </ng-container>

    <div
      *ngIf="!!justAddedText && _searchField.value === '' && _justAdded !== ''"
      class="messages messages--centered"
    >
      {{ _justAddedText }}
    </div>

    <!-- If no contacts at all other than you, if there are no groups at all, etc -->
    <div
      *ngIf="
        !!noListItemsText &&
        totalListItemsCount === 0 &&
        _justAdded === '' &&
        _searchField.value === ''
      "
      class="messages messages--centered"
    >
      {{ noListItemsText }}
    </div>
    <!-- If only a few items, give a hint as to why they're here -->
    <div
      *ngIf="
        !!fewListItemsText &&
        _listItems?.length >= 0 &&
        _listItems?.length < 4 &&
        _justAdded === '' &&
        _searchField.value === ''
      "
      class="messages messages--centered"
    >
      {{ fewListItemsText }}
    </div>
    <!-- If there are items but they're all selected -->
    <div
      *ngIf="
        !!allListItemsSelectedText &&
        totalListItemsCount > 0 &&
        _unselectedListItemsCount === 0
      "
      class="messages messages--centered"
    >
      {{ allListItemsSelectedText }}
    </div>

    <div *ngIf="_modalMode" class="action-block">
      <button
        class="button button--primary"
        type="button"
        (click)="closeModalMode.emit()"
      >
        Close
      </button>
    </div>
  </div>
</div>
